	.file	"powernotification-r0drv.c"
	.text
	.p2align 4,,15
.globl VBoxHost_RTPowerSignalEvent
	.type	VBoxHost_RTPowerSignalEvent, @function
VBoxHost_RTPowerSignalEvent:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	movl	$1, %esi
	pushl	%ebx
	subl	$20, %esp
	movl	$0, -16(%ebp)
#APP
# 2706 "/tmp/vboxdrv/include/iprt/asm.h" 1
	lock; xaddl %esi, g_iRTPowerDoneBit
	
# 0 "" 2
#NO_APP
	movl	$-38, %eax
	movl	g_hRTPowerNotifySpinLock, %edx
	testl	%edx, %edx
	je	.L2
	leal	-16(%ebp), %eax
	incl	%esi
	movl	%eax, 4(%esp)
	movl	%edx, (%esp)
	movl	%edx, -24(%ebp)
	andl	$31, %esi
	call	VBoxHost_RTSpinlockAcquire
	movl	g_pRTPowerCallbackHead, %eax
	movl	-24(%ebp), %edx
	testl	%eax, %eax
	je	.L14
	.p2align 4,,10
	.p2align 3
.L16:
#APP
# 3605 "/tmp/vboxdrv/include/iprt/asm.h" 1
	lock; btrl %esi, 12(%eax)
# 0 "" 2
#NO_APP
	movl	(%eax), %eax
	testl	%eax, %eax
	jne	.L16
.L14:
	movl	g_iRTPowerGeneration, %edi
	movl	g_pRTPowerCallbackHead, %ebx
	testl	%ebx, %ebx
	je	.L11
	movl	%edi, -20(%ebp)
	movl	%edx, %edi
	.p2align 4,,10
	.p2align 3
.L15:
#APP
# 3778 "/tmp/vboxdrv/include/iprt/asm.h" 1
	lock; btsl %esi, 12(%ebx)
	setc %al
	andl $1, %eax
	
# 0 "" 2
#NO_APP
	testb	%al, %al
	je	.L24
	movl	(%ebx), %ebx
.L8:
	testl	%ebx, %ebx
	jne	.L15
	movl	%edi, %edx
.L11:
	leal	-16(%ebp), %eax
	movl	%edx, (%esp)
	movl	%eax, 4(%esp)
	call	VBoxHost_RTSpinlockRelease
	xorl	%eax, %eax
.L2:
	addl	$20, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	leave
	ret
	.p2align 4,,10
	.p2align 3
.L24:
	movl	4(%ebx), %edi
	movl	8(%ebx), %eax
	leal	-16(%ebp), %ecx
	movl	(%ebx), %ebx
	movl	g_hRTPowerNotifySpinLock, %edx
	movl	%ecx, 4(%esp)
	movl	%edx, (%esp)
	movl	%eax, -24(%ebp)
	call	VBoxHost_RTSpinlockRelease
	movl	-24(%ebp), %eax
	movl	%eax, 4(%esp)
	movl	8(%ebp), %eax
	movl	%eax, (%esp)
	call	*%edi
	movl	g_hRTPowerNotifySpinLock, %edi
	testl	%edi, %edi
	je	.L13
	leal	-16(%ebp), %ecx
	movl	%edi, (%esp)
	movl	%ecx, 4(%esp)
	call	VBoxHost_RTSpinlockAcquire
	movl	g_iRTPowerGeneration, %eax
	cmpl	%eax, -20(%ebp)
	je	.L8
	movl	%edi, %edx
	testl	%ebx, %ebx
	jne	.L14
	jmp	.L11
.L13:
	movl	$-38, %eax
	.p2align 4,,2
	jmp	.L2
	.size	VBoxHost_RTPowerSignalEvent, .-VBoxHost_RTPowerSignalEvent
	.p2align 4,,15
.globl VBoxHost_RTPowerNotificationDeregister
	.type	VBoxHost_RTPowerNotificationDeregister, @function
VBoxHost_RTPowerNotificationDeregister:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$16, %esp
	movl	$0, -16(%ebp)
	movl	8(%ebp), %edi
	movl	12(%ebp), %esi
	leal	4096(%edi), %eax
	cmpl	$8191, %eax
	jbe	.L33
	movl	g_hRTPowerNotifySpinLock, %eax
	testl	%eax, %eax
	je	.L34
	leal	-16(%ebp), %ecx
	movl	g_hRTPowerNotifySpinLock, %eax
	movl	%ecx, 4(%esp)
	movl	%ecx, -20(%ebp)
	movl	%eax, (%esp)
	call	VBoxHost_RTSpinlockAcquire
	movl	g_pRTPowerCallbackHead, %ebx
	movl	-20(%ebp), %ecx
	testl	%ebx, %ebx
	je	.L27
	xorl	%edx, %edx
	jmp	.L30
	.p2align 4,,10
	.p2align 3
.L28:
	movl	(%ebx), %eax
	testl	%eax, %eax
	je	.L27
	movl	%ebx, %edx
	movl	%eax, %ebx
.L30:
	cmpl	%esi, 8(%ebx)
	jne	.L28
	cmpl	%edi, 4(%ebx)
	jne	.L28
	testl	%ebx, %ebx
	je	.L27
	testl	%edx, %edx
	.p2align 4,,4
	je	.L31
	movl	(%ebx), %eax
	movl	%eax, (%edx)
.L32:
	movl	$1, %eax
#APP
# 2706 "/tmp/vboxdrv/include/iprt/asm.h" 1
	lock; xaddl %eax, g_iRTPowerGeneration
	
# 0 "" 2
#NO_APP
	movl	g_hRTPowerNotifySpinLock, %eax
	movl	%ecx, 4(%esp)
	movl	%eax, (%esp)
	call	VBoxHost_RTSpinlockRelease
	movl	$0, (%ebx)
	movl	$0, 4(%ebx)
	movl	%ebx, (%esp)
	call	VBoxHost_RTMemFree
	xorl	%eax, %eax
.L26:
	addl	$16, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	leave
	ret
.L31:
	movl	(%ebx), %eax
	movl	%eax, g_pRTPowerCallbackHead
	jmp	.L32
.L33:
	movl	$-6, %eax
	jmp	.L26
.L27:
	movl	g_hRTPowerNotifySpinLock, %eax
	movl	%ecx, 4(%esp)
	movl	%eax, (%esp)
	call	VBoxHost_RTSpinlockRelease
	movl	$-78, %eax
	jmp	.L26
.L34:
	movl	$-22, %eax
	jmp	.L26
	.size	VBoxHost_RTPowerNotificationDeregister, .-VBoxHost_RTPowerNotificationDeregister
	.section	.rodata.str1.4,"aMS",@progbits,1
	.align 4
.LC0:
	.string	"/tmp/vboxdrv/r0drv/powernotification-r0drv.c"
	.text
	.p2align 4,,15
.globl VBoxHost_RTPowerNotificationRegister
	.type	VBoxHost_RTPowerNotificationRegister, @function
VBoxHost_RTPowerNotificationRegister:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$16, %esp
	movl	$0, -16(%ebp)
	movl	8(%ebp), %esi
	movl	12(%ebp), %ebx
	leal	4096(%esi), %eax
	cmpl	$8191, %eax
	jbe	.L48
	movl	g_hRTPowerNotifySpinLock, %eax
	testl	%eax, %eax
	je	.L49
	movl	g_hRTPowerNotifySpinLock, %eax
	leal	-16(%ebp), %edi
	movl	%eax, (%esp)
	movl	%edi, 4(%esp)
	call	VBoxHost_RTSpinlockAcquire
	movl	g_pRTPowerCallbackHead, %eax
	testl	%eax, %eax
	jne	.L53
	jmp	.L38
	.p2align 4,,10
	.p2align 3
.L39:
	movl	(%eax), %eax
	testl	%eax, %eax
	je	.L38
.L53:
	cmpl	%ebx, 8(%eax)
	.p2align 4,,4
	jne	.L39
	cmpl	%esi, 4(%eax)
	jne	.L39
	movl	g_hRTPowerNotifySpinLock, %edx
	movl	%eax, -20(%ebp)
	movl	%edi, 4(%esp)
	movl	%edx, (%esp)
	call	VBoxHost_RTSpinlockRelease
	movl	-20(%ebp), %eax
	testl	%eax, %eax
	je	.L47
	movl	$-105, %ecx
	jmp	.L37
	.p2align 4,,10
	.p2align 3
.L38:
	movl	g_hRTPowerNotifySpinLock, %eax
	movl	%edi, 4(%esp)
	movl	%eax, (%esp)
	call	VBoxHost_RTSpinlockRelease
.L47:
	movl	$.LC0, 4(%esp)
	movl	$16, (%esp)
	call	VBoxHost_RTMemAllocTag
	movl	$-8, %ecx
	testl	%eax, %eax
	je	.L37
	movl	$0, (%eax)
	movl	%esi, 4(%eax)
	movl	%ebx, 8(%eax)
	movl	$-1, 12(%eax)
	movl	g_hRTPowerNotifySpinLock, %edx
	movl	%eax, -20(%ebp)
	movl	%edx, (%esp)
	movl	%edi, 4(%esp)
	call	VBoxHost_RTSpinlockAcquire
	movl	g_pRTPowerCallbackHead, %edx
	movl	-20(%ebp), %eax
	testl	%edx, %edx
	je	.L55
	movl	g_pRTPowerCallbackHead, %edx
	jmp	.L46
	.p2align 4,,10
	.p2align 3
.L44:
	movl	(%edx), %ecx
	testl	%ecx, %ecx
	je	.L56
	movl	(%edx), %edx
.L46:
	cmpl	%ebx, 8(%edx)
	jne	.L44
	cmpl	%esi, 4(%edx)
	jne	.L44
	.p2align 4,,10
	.p2align 3
.L43:
	movl	$1, %eax
#APP
# 2706 "/tmp/vboxdrv/include/iprt/asm.h" 1
	lock; xaddl %eax, g_iRTPowerGeneration
	
# 0 "" 2
#NO_APP
	movl	g_hRTPowerNotifySpinLock, %eax
	movl	%edx, -20(%ebp)
	movl	%edi, 4(%esp)
	movl	%eax, (%esp)
	call	VBoxHost_RTSpinlockRelease
	xorl	%ecx, %ecx
	movl	-20(%ebp), %edx
	testl	%edx, %edx
	jne	.L57
.L37:
	addl	$16, %esp
	movl	%ecx, %eax
	popl	%ebx
	popl	%esi
	popl	%edi
	leave
	ret
	.p2align 4,,10
	.p2align 3
.L56:
	movl	%eax, (%edx)
	xorl	%edx, %edx
	jmp	.L43
.L55:
	movl	%eax, g_pRTPowerCallbackHead
	jmp	.L43
.L57:
	movl	%edx, (%esp)
	call	VBoxHost_RTMemFree
	movl	$-105, %ecx
	jmp	.L37
.L49:
	movl	$-22, %ecx
	jmp	.L37
.L48:
	movl	$-6, %ecx
	jmp	.L37
	.size	VBoxHost_RTPowerNotificationRegister, .-VBoxHost_RTPowerNotificationRegister
	.p2align 4,,15
.globl rtR0PowerNotificationInit
	.hidden	rtR0PowerNotificationInit
	.type	rtR0PowerNotificationInit, @function
rtR0PowerNotificationInit:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$4, %esp
	movl	$g_hRTPowerNotifySpinLock, (%esp)
	call	VBoxHost_RTSpinlockCreate
	leave
	ret
	.size	rtR0PowerNotificationInit, .-rtR0PowerNotificationInit
	.p2align 4,,15
.globl rtR0PowerNotificationTerm
	.hidden	rtR0PowerNotificationTerm
	.type	rtR0PowerNotificationTerm, @function
rtR0PowerNotificationTerm:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi
	pushl	%esi
	pushl	%ebx
	subl	$12, %esp
	movl	$0, -16(%ebp)
	movl	g_hRTPowerNotifySpinLock, %edi
	testl	%edi, %edi
	je	.L59
	leal	-16(%ebp), %esi
	movl	%edi, (%esp)
	movl	%esi, 4(%esp)
	call	VBoxHost_RTSpinlockAcquire
	xorl	%eax, %eax
#APP
# 377 "/tmp/vboxdrv/include/iprt/asm.h" 1
	xchgl g_hRTPowerNotifySpinLock, %eax
	
# 0 "" 2
#NO_APP
	movl	$1, %eax
	movl	g_pRTPowerCallbackHead, %ebx
	movl	$0, g_pRTPowerCallbackHead
#APP
# 2706 "/tmp/vboxdrv/include/iprt/asm.h" 1
	lock; xaddl %eax, g_iRTPowerGeneration
	
# 0 "" 2
#NO_APP
	movl	%esi, 4(%esp)
	movl	%edi, (%esp)
	call	VBoxHost_RTSpinlockRelease
	testl	%ebx, %ebx
	jne	.L64
	jmp	.L61
	.p2align 4,,10
	.p2align 3
.L63:
	movl	%esi, %ebx
.L64:
	movl	(%ebx), %esi
	movl	$0, 4(%ebx)
	movl	$0, (%ebx)
	movl	%ebx, (%esp)
	call	VBoxHost_RTMemFree
	testl	%esi, %esi
	jne	.L63
.L61:
	movl	%edi, (%esp)
	call	VBoxHost_RTSpinlockDestroy
.L59:
	addl	$12, %esp
	popl	%ebx
	popl	%esi
	popl	%edi
	leave
	ret
	.size	rtR0PowerNotificationTerm, .-rtR0PowerNotificationTerm
	.section	___ksymtab+VBoxHost_RTPowerNotificationDeregister,"a",@progbits
	.align 4
	.type	__ksymtab_VBoxHost_RTPowerNotificationDeregister, @object
	.size	__ksymtab_VBoxHost_RTPowerNotificationDeregister, 8
__ksymtab_VBoxHost_RTPowerNotificationDeregister:
	.long	VBoxHost_RTPowerNotificationDeregister
	.long	__kstrtab_VBoxHost_RTPowerNotificationDeregister
	.section	___ksymtab+VBoxHost_RTPowerNotificationRegister,"a",@progbits
	.align 4
	.type	__ksymtab_VBoxHost_RTPowerNotificationRegister, @object
	.size	__ksymtab_VBoxHost_RTPowerNotificationRegister, 8
__ksymtab_VBoxHost_RTPowerNotificationRegister:
	.long	VBoxHost_RTPowerNotificationRegister
	.long	__kstrtab_VBoxHost_RTPowerNotificationRegister
	.section	___ksymtab+VBoxHost_RTPowerSignalEvent,"a",@progbits
	.align 4
	.type	__ksymtab_VBoxHost_RTPowerSignalEvent, @object
	.size	__ksymtab_VBoxHost_RTPowerSignalEvent, 8
__ksymtab_VBoxHost_RTPowerSignalEvent:
	.long	VBoxHost_RTPowerSignalEvent
	.long	__kstrtab_VBoxHost_RTPowerSignalEvent
	.local	g_hRTPowerNotifySpinLock
	.comm	g_hRTPowerNotifySpinLock,4,4
	.local	g_pRTPowerCallbackHead
	.comm	g_pRTPowerCallbackHead,4,4
	.local	g_iRTPowerGeneration
	.comm	g_iRTPowerGeneration,4,4
	.local	g_iRTPowerDoneBit
	.comm	g_iRTPowerDoneBit,4,4
	.section	__ksymtab_strings,"a",@progbits
	.type	__kstrtab_VBoxHost_RTPowerNotificationDeregister, @object
	.size	__kstrtab_VBoxHost_RTPowerNotificationDeregister, 39
__kstrtab_VBoxHost_RTPowerNotificationDeregister:
	.string	"VBoxHost_RTPowerNotificationDeregister"
	.type	__kstrtab_VBoxHost_RTPowerNotificationRegister, @object
	.size	__kstrtab_VBoxHost_RTPowerNotificationRegister, 37
__kstrtab_VBoxHost_RTPowerNotificationRegister:
	.string	"VBoxHost_RTPowerNotificationRegister"
	.type	__kstrtab_VBoxHost_RTPowerSignalEvent, @object
	.size	__kstrtab_VBoxHost_RTPowerSignalEvent, 28
__kstrtab_VBoxHost_RTPowerSignalEvent:
	.string	"VBoxHost_RTPowerSignalEvent"
	.ident	"GCC: (GNU) 4.5.3 (birdie)"
	.section	.note.GNU-stack,"",@progbits
