	.file	"thread-r0drv-linux.c"
	.text
	.p2align 4,,15
.globl VBoxHost_RTThreadNativeSelf
	.type	VBoxHost_RTThreadNativeSelf, @function
VBoxHost_RTThreadNativeSelf:
	pushl	%ebp
	movl	%esp, %ebp
	leave
#APP
# 14 "/usr/src/kernels/linux-3.0/arch/x86/include/asm/current.h" 1
	movl %fs:current_task,%eax
# 0 "" 2
#NO_APP
	ret
	.size	VBoxHost_RTThreadNativeSelf, .-VBoxHost_RTThreadNativeSelf
	.p2align 4,,15
.globl VBoxHost_RTThreadPreemptIsEnabled
	.type	VBoxHost_RTThreadPreemptIsEnabled, @function
VBoxHost_RTThreadPreemptIsEnabled:
	pushl	%ebp
	xorl	%eax, %eax
	movl	%esp, %edx
	movl	%esp, %ebp
	andl	$-8192, %edx
	movl	20(%edx), %edx
	testl	%edx, %edx
	jne	.L3
#APP
# 20 "/usr/src/kernels/linux-3.0/arch/x86/include/asm/irqflags.h" 1
	# __raw_save_flags
	pushf ; pop %eax
# 0 "" 2
#NO_APP
	testb	$2, %ah
	setne	%al
.L3:
	leave
	ret
	.size	VBoxHost_RTThreadPreemptIsEnabled, .-VBoxHost_RTThreadPreemptIsEnabled
	.p2align 4,,15
.globl VBoxHost_RTThreadPreemptIsPending
	.type	VBoxHost_RTThreadPreemptIsPending, @function
VBoxHost_RTThreadPreemptIsPending:
	pushl	%ebp
	movl	%esp, %ebp
#APP
# 14 "/usr/src/kernels/linux-3.0/arch/x86/include/asm/current.h" 1
	movl %fs:current_task,%eax
# 0 "" 2
#NO_APP
	movl	4(%eax), %eax
	movl	8(%eax), %eax
	leave
	shrl	$3, %eax
	andl	$1, %eax
	ret
	.size	VBoxHost_RTThreadPreemptIsPending, .-VBoxHost_RTThreadPreemptIsPending
	.p2align 4,,15
.globl VBoxHost_RTThreadPreemptIsPendingTrusty
	.type	VBoxHost_RTThreadPreemptIsPendingTrusty, @function
VBoxHost_RTThreadPreemptIsPendingTrusty:
	pushl	%ebp
	movl	$1, %eax
	movl	%esp, %ebp
	leave
	ret
	.size	VBoxHost_RTThreadPreemptIsPendingTrusty, .-VBoxHost_RTThreadPreemptIsPendingTrusty
	.p2align 4,,15
.globl VBoxHost_RTThreadPreemptIsPossible
	.type	VBoxHost_RTThreadPreemptIsPossible, @function
VBoxHost_RTThreadPreemptIsPossible:
	pushl	%ebp
	movl	$1, %eax
	movl	%esp, %ebp
	leave
	ret
	.size	VBoxHost_RTThreadPreemptIsPossible, .-VBoxHost_RTThreadPreemptIsPossible
	.p2align 4,,15
.globl VBoxHost_RTThreadPreemptDisable
	.type	VBoxHost_RTThreadPreemptDisable, @function
VBoxHost_RTThreadPreemptDisable:
	pushl	%ebp
	movl	%esp, %ebp
	movl	8(%ebp), %eax
	movl	$42, 4(%eax)
	movl	%esp, %eax
	andl	$-8192, %eax
	incl	20(%eax)
	leave
	ret
	.size	VBoxHost_RTThreadPreemptDisable, .-VBoxHost_RTThreadPreemptDisable
	.p2align 4,,15
.globl VBoxHost_RTThreadIsInInterrupt
	.type	VBoxHost_RTThreadIsInInterrupt, @function
VBoxHost_RTThreadIsInInterrupt:
	pushl	%ebp
	movl	%esp, %eax
	movl	%esp, %ebp
	andl	$-8192, %eax
	testl	$134217472, 20(%eax)
	leave
	setne	%al
	ret
	.size	VBoxHost_RTThreadIsInInterrupt, .-VBoxHost_RTThreadIsInInterrupt
	.p2align 4,,15
.globl VBoxHost_RTThreadPreemptRestore
	.type	VBoxHost_RTThreadPreemptRestore, @function
VBoxHost_RTThreadPreemptRestore:
	pushl	%ebp
	movl	%esp, %ebp
	movl	%esp, %eax
	andl	$-8192, %eax
	decl	20(%eax)
	movl	8(%eax), %eax
	testb	$8, %al
	jne	.L13
.L12:
	movl	8(%ebp), %eax
	movl	$0, 4(%eax)
	leave
	ret
.L13:
	call	preempt_schedule
	jmp	.L12
	.size	VBoxHost_RTThreadPreemptRestore, .-VBoxHost_RTThreadPreemptRestore
	.p2align 4,,15
.globl VBoxHost_RTThreadYield
	.type	VBoxHost_RTThreadYield, @function
VBoxHost_RTThreadYield:
	pushl	%ebp
	movl	%esp, %ebp
	call	yield
	movl	$1, %eax
	leave
	ret
	.size	VBoxHost_RTThreadYield, .-VBoxHost_RTThreadYield
	.p2align 4,,15
.globl VBoxHost_RTThreadSleep
	.type	VBoxHost_RTThreadSleep, @function
VBoxHost_RTThreadSleep:
	pushl	%ebp
	movl	%esp, %ebp
	subl	$4, %esp
	movl	8(%ebp), %eax
	call	msecs_to_jiffies
	movl	$1, -4(%ebp)
	movl	-4(%ebp), %edx
#APP
# 14 "/usr/src/kernels/linux-3.0/arch/x86/include/asm/current.h" 1
	movl %fs:current_task,%ecx
# 0 "" 2
# 63 "/tmp/vboxdrv/r0drv/linux/thread-r0drv-linux.c" 1
	xchgl %edx,(%ecx)
# 0 "" 2
#NO_APP
	movl	%edx, -4(%ebp)
	movl	-4(%ebp), %edx
	call	schedule_timeout
	leave
	cmpl	$1, %eax
	sbbl	%eax, %eax
	notl	%eax
	andl	$-39, %eax
	ret
	.size	VBoxHost_RTThreadSleep, .-VBoxHost_RTThreadSleep
	.section	___ksymtab+VBoxHost_RTThreadIsInInterrupt,"a",@progbits
	.align 4
	.type	__ksymtab_VBoxHost_RTThreadIsInInterrupt, @object
	.size	__ksymtab_VBoxHost_RTThreadIsInInterrupt, 8
__ksymtab_VBoxHost_RTThreadIsInInterrupt:
	.long	VBoxHost_RTThreadIsInInterrupt
	.long	__kstrtab_VBoxHost_RTThreadIsInInterrupt
	.section	___ksymtab+VBoxHost_RTThreadPreemptRestore,"a",@progbits
	.align 4
	.type	__ksymtab_VBoxHost_RTThreadPreemptRestore, @object
	.size	__ksymtab_VBoxHost_RTThreadPreemptRestore, 8
__ksymtab_VBoxHost_RTThreadPreemptRestore:
	.long	VBoxHost_RTThreadPreemptRestore
	.long	__kstrtab_VBoxHost_RTThreadPreemptRestore
	.section	___ksymtab+VBoxHost_RTThreadPreemptDisable,"a",@progbits
	.align 4
	.type	__ksymtab_VBoxHost_RTThreadPreemptDisable, @object
	.size	__ksymtab_VBoxHost_RTThreadPreemptDisable, 8
__ksymtab_VBoxHost_RTThreadPreemptDisable:
	.long	VBoxHost_RTThreadPreemptDisable
	.long	__kstrtab_VBoxHost_RTThreadPreemptDisable
	.section	___ksymtab+VBoxHost_RTThreadPreemptIsPossible,"a",@progbits
	.align 4
	.type	__ksymtab_VBoxHost_RTThreadPreemptIsPossible, @object
	.size	__ksymtab_VBoxHost_RTThreadPreemptIsPossible, 8
__ksymtab_VBoxHost_RTThreadPreemptIsPossible:
	.long	VBoxHost_RTThreadPreemptIsPossible
	.long	__kstrtab_VBoxHost_RTThreadPreemptIsPossible
	.section	___ksymtab+VBoxHost_RTThreadPreemptIsPendingTrusty,"a",@progbits
	.align 4
	.type	__ksymtab_VBoxHost_RTThreadPreemptIsPendingTrusty, @object
	.size	__ksymtab_VBoxHost_RTThreadPreemptIsPendingTrusty, 8
__ksymtab_VBoxHost_RTThreadPreemptIsPendingTrusty:
	.long	VBoxHost_RTThreadPreemptIsPendingTrusty
	.long	__kstrtab_VBoxHost_RTThreadPreemptIsPendingTrusty
	.section	___ksymtab+VBoxHost_RTThreadPreemptIsPending,"a",@progbits
	.align 4
	.type	__ksymtab_VBoxHost_RTThreadPreemptIsPending, @object
	.size	__ksymtab_VBoxHost_RTThreadPreemptIsPending, 8
__ksymtab_VBoxHost_RTThreadPreemptIsPending:
	.long	VBoxHost_RTThreadPreemptIsPending
	.long	__kstrtab_VBoxHost_RTThreadPreemptIsPending
	.section	___ksymtab+VBoxHost_RTThreadPreemptIsEnabled,"a",@progbits
	.align 4
	.type	__ksymtab_VBoxHost_RTThreadPreemptIsEnabled, @object
	.size	__ksymtab_VBoxHost_RTThreadPreemptIsEnabled, 8
__ksymtab_VBoxHost_RTThreadPreemptIsEnabled:
	.long	VBoxHost_RTThreadPreemptIsEnabled
	.long	__kstrtab_VBoxHost_RTThreadPreemptIsEnabled
	.section	___ksymtab+VBoxHost_RTThreadYield,"a",@progbits
	.align 4
	.type	__ksymtab_VBoxHost_RTThreadYield, @object
	.size	__ksymtab_VBoxHost_RTThreadYield, 8
__ksymtab_VBoxHost_RTThreadYield:
	.long	VBoxHost_RTThreadYield
	.long	__kstrtab_VBoxHost_RTThreadYield
	.section	___ksymtab+VBoxHost_RTThreadSleep,"a",@progbits
	.align 4
	.type	__ksymtab_VBoxHost_RTThreadSleep, @object
	.size	__ksymtab_VBoxHost_RTThreadSleep, 8
__ksymtab_VBoxHost_RTThreadSleep:
	.long	VBoxHost_RTThreadSleep
	.long	__kstrtab_VBoxHost_RTThreadSleep
	.section	___ksymtab+VBoxHost_RTThreadNativeSelf,"a",@progbits
	.align 4
	.type	__ksymtab_VBoxHost_RTThreadNativeSelf, @object
	.size	__ksymtab_VBoxHost_RTThreadNativeSelf, 8
__ksymtab_VBoxHost_RTThreadNativeSelf:
	.long	VBoxHost_RTThreadNativeSelf
	.long	__kstrtab_VBoxHost_RTThreadNativeSelf
	.section	__ksymtab_strings,"a",@progbits
	.type	__kstrtab_VBoxHost_RTThreadIsInInterrupt, @object
	.size	__kstrtab_VBoxHost_RTThreadIsInInterrupt, 31
__kstrtab_VBoxHost_RTThreadIsInInterrupt:
	.string	"VBoxHost_RTThreadIsInInterrupt"
	.type	__kstrtab_VBoxHost_RTThreadPreemptRestore, @object
	.size	__kstrtab_VBoxHost_RTThreadPreemptRestore, 32
__kstrtab_VBoxHost_RTThreadPreemptRestore:
	.string	"VBoxHost_RTThreadPreemptRestore"
	.type	__kstrtab_VBoxHost_RTThreadPreemptDisable, @object
	.size	__kstrtab_VBoxHost_RTThreadPreemptDisable, 32
__kstrtab_VBoxHost_RTThreadPreemptDisable:
	.string	"VBoxHost_RTThreadPreemptDisable"
	.type	__kstrtab_VBoxHost_RTThreadPreemptIsPossible, @object
	.size	__kstrtab_VBoxHost_RTThreadPreemptIsPossible, 35
__kstrtab_VBoxHost_RTThreadPreemptIsPossible:
	.string	"VBoxHost_RTThreadPreemptIsPossible"
	.type	__kstrtab_VBoxHost_RTThreadPreemptIsPendingTrusty, @object
	.size	__kstrtab_VBoxHost_RTThreadPreemptIsPendingTrusty, 40
__kstrtab_VBoxHost_RTThreadPreemptIsPendingTrusty:
	.string	"VBoxHost_RTThreadPreemptIsPendingTrusty"
	.type	__kstrtab_VBoxHost_RTThreadPreemptIsPending, @object
	.size	__kstrtab_VBoxHost_RTThreadPreemptIsPending, 34
__kstrtab_VBoxHost_RTThreadPreemptIsPending:
	.string	"VBoxHost_RTThreadPreemptIsPending"
	.type	__kstrtab_VBoxHost_RTThreadPreemptIsEnabled, @object
	.size	__kstrtab_VBoxHost_RTThreadPreemptIsEnabled, 34
__kstrtab_VBoxHost_RTThreadPreemptIsEnabled:
	.string	"VBoxHost_RTThreadPreemptIsEnabled"
	.type	__kstrtab_VBoxHost_RTThreadYield, @object
	.size	__kstrtab_VBoxHost_RTThreadYield, 23
__kstrtab_VBoxHost_RTThreadYield:
	.string	"VBoxHost_RTThreadYield"
	.type	__kstrtab_VBoxHost_RTThreadSleep, @object
	.size	__kstrtab_VBoxHost_RTThreadSleep, 23
__kstrtab_VBoxHost_RTThreadSleep:
	.string	"VBoxHost_RTThreadSleep"
	.type	__kstrtab_VBoxHost_RTThreadNativeSelf, @object
	.size	__kstrtab_VBoxHost_RTThreadNativeSelf, 28
__kstrtab_VBoxHost_RTThreadNativeSelf:
	.string	"VBoxHost_RTThreadNativeSelf"
	.ident	"GCC: (GNU) 4.5.3 (birdie)"
	.section	.note.GNU-stack,"",@progbits
